#  (2021-11-25)


### Bug Fixes

* add missing application pom and classes ([75c26ee](https://github.com/Roche/the-ambassador/commit/75c26ee6cdc434bee3d502b6c6ce828e627d8fb2))
* **ci:** add contributors to readme for pull requests ([4c5bcac](https://github.com/Roche/the-ambassador/commit/4c5bcac93c4cd4dbf01c4cbde913ad8b7c1f4e41))
* **gitlab-client:** fix paging when next page index is returned instead of total pages ([e2511d7](https://github.com/Roche/the-ambassador/commit/e2511d72a8bedf56e58ba1f64ced2a61cbaa41a3))
* **gitlab-client:** invalid type for fields dueDate and startDate for milestones ([354d9b0](https://github.com/Roche/the-ambassador/commit/354d9b0bc509a3caf2e3e270886af80cf11ff968))
* **indexer:** centralize indexer concurrency configuration to control threads pool and do not hit system threads limit ([1c4a736](https://github.com/Roche/the-ambassador/commit/1c4a736bc9f63ba703beb6aef6edbe0d192185f8))
* **indexer:** fix invalid logging of projects which should not be indexed ([5d4d7cd](https://github.com/Roche/the-ambassador/commit/5d4d7cde083a2eaad37c0b89fe27903aa3ecda30))
* re-enable fetching single project from source repository ([14026ac](https://github.com/Roche/the-ambassador/commit/14026acc41e41ac9bd2a8cc56b3d7f865666c5f2))
* **text-analyzer:** fix issue with leaking threads causing ambassador exceed OS threads limit ([b5b99e8](https://github.com/Roche/the-ambassador/commit/b5b99e8bfa28d7a4ee2532db53dd39541e789933))
* use jackson kotlin module to fix issues with json deserialization when data classes are used ([4db2b02](https://github.com/Roche/the-ambassador/commit/4db2b02bc91e4700ac9ec1268df650b63937ce24))


### Features

* add API to list indexed projects with paging and sorting ([87c2a3e](https://github.com/Roche/the-ambassador/commit/87c2a3efbd30954cc4e7b7b79365d6d4f3e3a5ea))
* add caching / storage in PostgreSQL ([6ae9948](https://github.com/Roche/the-ambassador/commit/6ae994864ac2527306a1a07c91c1e58d7e8a55b2))
* add total score calculation ([43ce21f](https://github.com/Roche/the-ambassador/commit/43ce21ff0fb2ad8b03843ba110cdddd736cf780c))
* allow lowercased enums in request parameters ([ba9dcad](https://github.com/Roche/the-ambassador/commit/ba9dcadf7df5d0670a673fe119ea4b5aac846de3))
* **api:** add generation of OpenApi v3 documentation ([83ef611](https://github.com/Roche/the-ambassador/commit/83ef6114c712586dea95836a0dd546d3fb7b62bf))
* **client:** use non-blocking gitlab client and rename package from pl.filipowm to com.filipowm ([fea7b60](https://github.com/Roche/the-ambassador/commit/fea7b60432f715c0981be1eb295298718b84295e))
* configure JSON object mapper ([6e34e39](https://github.com/Roche/the-ambassador/commit/6e34e397c4b73a135f7ecd68b9e9ce7410c562a0))
* create non-blocking gitlab client ([2536aae](https://github.com/Roche/the-ambassador/commit/2536aaecc466e11410025229d9d7e3c1d626996e))
* create project model ([ba9bd57](https://github.com/Roche/the-ambassador/commit/ba9bd57db9955b5a359092694afd1dedabbd480a))
* enable GitLab integration ([80b98fb](https://github.com/Roche/the-ambassador/commit/80b98fbe98b36b9e182ba7c153ec6e1c0ae86521))
* enable text search in name and excerpt ([f74e492](https://github.com/Roche/the-ambassador/commit/f74e492b29f3558e2088df495cc90984f27a9b5c))
* **fake-source:** add more data generation to fake source ([4e22444](https://github.com/Roche/the-ambassador/commit/4e2244494cfaf18efb1407faad80a679638d56ad))
* **fake-source:** create fake project source for generating dummy data for testing ambassador ([15c091b](https://github.com/Roche/the-ambassador/commit/15c091b9ae0f294f968b97d0f49814f9c326b695))
* **fake-source:** use timeline generation to generate timeline data ([6c1553c](https://github.com/Roche/the-ambassador/commit/6c1553cb8e3d26afddef825080290ab156db4868))
* **gitlab-client:** add forkingAccessLevel and mergeRequestsAccessLevel to project model ([f6aa4be](https://github.com/Roche/the-ambassador/commit/f6aa4be7739b183ffca5cb4974ea505460aeffa5))
* **gitlab-client:** add packages API support ([ebfae7f](https://github.com/Roche/the-ambassador/commit/ebfae7fcb7b21f093d095375e2513bcd0435cccf))
* **gitlab-client:** add pipelines API support ([4bc66ee](https://github.com/Roche/the-ambassador/commit/4bc66ee2916372dcf547be567161ca66e854114b))
* **gitlab-client:** add project members API support ([d5cb307](https://github.com/Roche/the-ambassador/commit/d5cb3070b5d0857b8ccaeda88dafa5bbc905b9bf))
* **gitlab-client:** add project merge requests API support ([0107d46](https://github.com/Roche/the-ambassador/commit/0107d4680a72223528935994d03f87ee307beb3b))
* **gitlab-client:** enable retries on errors, including support for rate limiting and adjusting retry delay based on retry-after header ([676edf7](https://github.com/Roche/the-ambassador/commit/676edf70d4d8a5582d4ba03105e67221f3cdd69c))
* **gitlab-client:** read fork relationship information for forked projects ([b712f9b](https://github.com/Roche/the-ambassador/commit/b712f9bcc116231dea26f1468037fd59ed006505))
* **groups:** index groups, add API for fetching groups including full text search ([cb2bee0](https://github.com/Roche/the-ambassador/commit/cb2bee09d19de9f9ec505105dbd163876eda7b5b))
* **i18n:** enable internationalization support ([450c712](https://github.com/Roche/the-ambassador/commit/450c712a5ff3c828fd4c8439b5a1a2f6d2c50fe7))
* index all features as is, without additional re-calculation ([5ed74d2](https://github.com/Roche/the-ambassador/commit/5ed74d202c83aea90c9cf2d7eeac50199ca654a2))
* **indexer:** block indexing of new projects when indexing is already running ([d066b7e](https://github.com/Roche/the-ambassador/commit/d066b7e587e51da072f9c48f4ff7402582b755c1))
* **indexer:** increase default page size for fetching projects from gitlab ([3ae0143](https://github.com/Roche/the-ambassador/commit/3ae0143e506b1e85705fd17a6fe17a4e3293a386))
* **indexing:** add aggregated project members to project indexing ([6e1948b](https://github.com/Roche/the-ambassador/commit/6e1948b1f962bc8288d6ee010253a8b7d7cc09c6))
* **indexing:** add excluded projects to indexing statistics and report ([9740f00](https://github.com/Roche/the-ambassador/commit/9740f00a1c6e07221b992a0047906042c32db229))
* **indexing:** add forked projects indexing criteria ([aeec88c](https://github.com/Roche/the-ambassador/commit/aeec88c5ff441ace10984ad158b2dfe60e33c634))
* **indexing:** add option to terminate consumer separetely from producer when forcibly stopping indexing ([e938e64](https://github.com/Roche/the-ambassador/commit/e938e64e0ad5fc261b705c9a63c6da63c9e7e93d))
* **indexing:** add pull requests timeline to project indexing ([e7bcd7a](https://github.com/Roche/the-ambassador/commit/e7bcd7ab658d7907bf052d3adebb8f4c65f232e4))
* **indexing:** allow configuration of indexing criteria ([dbec1e8](https://github.com/Roche/the-ambassador/commit/dbec1e8648346ea8802646c79a401ade8ffee03f))
* **indexing:** allow indexing only specific groups / workspaces / organizations ([af7cd4f](https://github.com/Roche/the-ambassador/commit/af7cd4ff61845bc340dbd7614204df64d0a7bbd2))
* **indexing:** create and uuse invalid project criteria to filter out invalid projects, which are not intended for open/inner sourcing ([8778624](https://github.com/Roche/the-ambassador/commit/87786247ea3945aaf8da6cbb26df5dadd10c5051))
* **indexing:** exclude personal projects with 0 stars ([39e10fc](https://github.com/Roche/the-ambassador/commit/39e10fc0e6ac9cac2973f290d92b3e7b72137d63))
* **indexing:** filter out projects with activity older than half a year ([389216e](https://github.com/Roche/the-ambassador/commit/389216e3b910bab06399dcfc54e8dd9b6cef8e50))
* **indexing:** incremental indexing, reading project features only when project has changed since last indexing ([af4efda](https://github.com/Roche/the-ambassador/commit/af4efda74943d7de3d72d84fab86fffcb105f5d9))
* **indexing:** index readme, contributing and license files ([653337f](https://github.com/Roche/the-ambassador/commit/653337fb266569ed0fe759d2d8c14ee1514f1d03))
* **indexing:** provide indexing statistics and final indexing report (in logs) ([03e6239](https://github.com/Roche/the-ambassador/commit/03e6239ade404721bdb6c8d990320fa5485a6158))
* **indexing:** read more data needed for criticality score, improve reading concurrently ([25bd483](https://github.com/Roche/the-ambassador/commit/25bd483c05fe19850b4a253a04fefcb442b32341))
* **indexing:** stop indexing when application is shutting down ([6797fa1](https://github.com/Roche/the-ambassador/commit/6797fa1ea0ff88ad740ff1ee2161bfc4e16a0418))
* **indexing:** store history and state of each indexing, switch to use database lock for indexing ([6418db2](https://github.com/Roche/the-ambassador/commit/6418db20fda40e76dcadf3a2820621645adde46a))
* **indexing:** use date of last indexing to determine if project is eligible for indexing ([05d2177](https://github.com/Roche/the-ambassador/commit/05d21779905c3389166d9d7938d1ab2de33123b5))
* initialize application layer ([344ad7f](https://github.com/Roche/the-ambassador/commit/344ad7f5a1dc5704ba98066e4584845b1a9734c8))
* initialize document analyzer with language detection and null interfaces ([a0e2b6b](https://github.com/Roche/the-ambassador/commit/a0e2b6be35b9698f197a42a41a8b51df5fa5646d))
* **model:** switch from defining fixed project properties to more flexible model based on features ([bbec8c9](https://github.com/Roche/the-ambassador/commit/bbec8c9af38a9343f8d3f904a25dc86895ed8d1a))
* move gitlab exception handling from repository to client, so that any calls to gitlab are safely wrapped in proper exceptions ([d6d80e5](https://github.com/Roche/the-ambassador/commit/d6d80e596f7ed9c46fbbb8912226ec586f3b46d0))
* move indexing to dedicated API ([4744315](https://github.com/Roche/the-ambassador/commit/47443157ecbd7926a9e8ca346fc59a7dc889fd5e))
* **project:** add project history with possibility of querying results of previous indexing executions for given project ([989e7a3](https://github.com/Roche/the-ambassador/commit/989e7a3b0bc0cf085a72ebcf967f19b92ee4d862))
* **project:** project history API should sort by indexed daet by default ([aa4e44b](https://github.com/Roche/the-ambassador/commit/aa4e44b0ffae2ed1ff4d843c0b98ea91a4dc86d7))
* **project:** timeline feature does not provide raw data, but statistical information about the timeline ([172b1ff](https://github.com/Roche/the-ambassador/commit/172b1ff901a23ee57b6064f3d2c4c0bc15d0a9b2))
* read all important files ([a271e9b](https://github.com/Roche/the-ambassador/commit/a271e9b218d148f64be05b74242183051d1e7ddb))
* read project statistics ([53c1caa](https://github.com/Roche/the-ambassador/commit/53c1caa84c82d500aeeeb99793094f587f80a3f0))
* rename indexEvery property to grace period ([cba532c](https://github.com/Roche/the-ambassador/commit/cba532c42d09c038aa46ba0361eafc4e5b17a7e0))
* return JSON message about processing started ([9b8f1ad](https://github.com/Roche/the-ambassador/commit/9b8f1adb54df9d0115f8d30cf331031ebc8a0877))
* **score:** add calculation of criticality score using new method ([061e94f](https://github.com/Roche/the-ambassador/commit/061e94f69ee4a421d897907f5277437ef90eee74))
* **scorecard:** add project scorecard including all subscores ([fae8fe7](https://github.com/Roche/the-ambassador/commit/fae8fe763851225ade79fc4ff1f8a412cc117439))
* **score:** migrate calculation of activity score to new Score model ([5aea30f](https://github.com/Roche/the-ambassador/commit/5aea30fb97cdd097a06eac44bcbc1ed34e131af8))
* **score:** tune activity score and add open issues partial to this score ([1677f92](https://github.com/Roche/the-ambassador/commit/1677f92e523a34439e768818f361b1a5d3b24cc5))
* **search:** enable full text search ([820d858](https://github.com/Roche/the-ambassador/commit/820d858f0a2d5f357cc787142ce839448b441c83))
* **security:** add authentication failure handler ([309108b](https://github.com/Roche/the-ambassador/commit/309108bce205d913692c927abe039cf53b4b004a))
* **security:** allow indexing API to be used by admin users only, create and use custom user principal ([17207d6](https://github.com/Roche/the-ambassador/commit/17207d6b83e98bc22e431c240051c25e684642a2))
* **security:** build OAuth2 client based on project source configuration ([54acba0](https://github.com/Roche/the-ambassador/commit/54acba0d81853b5ab8fb82248903f997edf17316))
* **security:** initialize OAuth2 security ([b3eb74a](https://github.com/Roche/the-ambassador/commit/b3eb74aea4591e35bf86578d468956b33df717b2))
* **security:** make session duration configurable and add logging of successful log-in events ([eb06bf7](https://github.com/Roche/the-ambassador/commit/eb06bf75e2f64546e6b55806da096e60bc46c819))


### Performance Improvements

* **gitlab-client:** make gitlab client fully non-blocking ([3016afc](https://github.com/Roche/the-ambassador/commit/3016afc255caf3e6b5604d21b406acb9dc26ae78))



